#define CMDNAME       		"intspy"
#define VERSION       		"1.3"
#define COPYRIGHT     		"copyright (C) 1993-1995 Frits Wiarda"

#define HELP    		\
"Monitor interrupts while running a program.\n"\
"\n"\
"Usage: intspy [-setup] logfile command [parameters]\n"\
"\n"\
"In the section [intspy.setup] in the file intspy.ini, is a list of\n"\
"interrupts to be monitored, and the names of the sections in which the\n"\
"logging texts for that interrupt are found. If setup is not specified,\n"\
"intspy looks in the section [intspy.default] instead.\n"\
"\n"\
"Logfile is the name of the file the loggings must be written to.\n"\
"\n"\
"Command is the program to run.\n"\
"\n"\
"Parameters are the optional parameters for command.\n"

#define USAGE           	\
"Usage: intspy [-setup] logfile command [parameters]\n"

#define STRING_SIZE     	      	  	192
#define A_STRING_SIZE     	      	  	64
#define H_STRING_SIZE     	      	  	64
#define PRINT_BUFFER_SIZE             		8192 
#define MAX_SPY_MESSAGE_LENGTH         		2048 
#define INT_HANDLER_STACK_SIZE        		8192

#define INI_FILE_NAME				"intspy.ini"
#define SETUP_SECTION_PREFIX         		"intspy."
#define DEFAULT_SETUP_SECTION_SUFFIX        	"default"
#define DEFAULT_DESCRIPTION_SECTION		"default"

#define MAX_INT_HANDLERS			8
#define PATH_SIZE				1024
#define PATH_TABLE_SIZE				128
#define PATH_ENVIRONMENT_VAR			"PATH"
#define CURRENT_DIRECTORY			"."
#define PATH_ENVIRONMENT_DELIMITER		';'
#define PATH_ENVIRONMENT_DELIMITER_2		';'
#define PATH_ENVIRONMENT_DELIMITER_3		';'
#define DIRECTORY_NAME_SEPARATOR		'\\'
#define DIRECTORY_NAME_SEPARATOR_2		'/'
#define DIRECTORY_NAME_SEPARATOR_3		':'



struct INT_TAB {
	int condition[8];
	char *description[8];
};

struct SPY_TAB {
	int interrupt_no;
	char *section;
};



void _interrupt _far new_int_handler_0(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags);
void _interrupt _far new_int_handler_1(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags);
void _interrupt _far new_int_handler_2(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags);
void _interrupt _far new_int_handler_3(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags);
void _interrupt _far new_int_handler_4(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags);
void _interrupt _far new_int_handler_5(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags);
void _interrupt _far new_int_handler_6(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags);
void _interrupt _far new_int_handler_7(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags);


void spy(struct INT_TAB int_tab[]);
unsigned int get_par(char *parameter);
char *get_first_par(char *parameter);
void lprintf(char *p1,...);
void _huge *make_huge_pointer(unsigned int segment,unsigned int offset);
int dos_bysy(void);

int read_int_tab(char ini_file_name[],char ini_file_section[],
	struct INT_TAB **int_tab);
int char_to_hex(char c);

int read_spy_tab(char ini_file_name[],char ini_file_section[],
	struct SPY_TAB **spy_tab);

int get_private_profile_string(char section[],char *item,char default_result[],
	char result[],int size_of_result,char ini_file_name[]);



extern char *log_file_name;

extern struct INT_TAB *int_tab[MAX_INT_HANDLERS];

extern struct SPY_TAB *spy_tab;

extern int in_our_own_code;

extern void (_interrupt _far *old_int_handler[MAX_INT_HANDLERS])();

extern char _huge *int_handler_stack_pointer;

extern char _huge *old_stack_pointer;

extern unsigned int res;
extern unsigned int rds;
extern unsigned int rdi;
extern unsigned int rsi;
extern unsigned int rbp;
extern unsigned int rsp;
extern unsigned int rbx;
extern unsigned int rdx;
extern unsigned int rcx;
extern unsigned int rax;
extern unsigned int rip;
extern unsigned int rcs;
extern unsigned int rflags;
extern unsigned int rss;

extern unsigned int current_interrupt_no;



