#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include "intspy.h"






/* Own interupt handler number 0. */
void _interrupt _far new_int_handler_0(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags)
{
	/* If the flag in_our_own_code is set, interrupt is recursively
	called by our own interrupt handler. In this case we chain to
	the original interrupt handler. */
	if(in_our_own_code)_chain_intr(old_int_handler[0]);

	/* Otherwise we will do our own interrupt processing. */
	else 
	{
		/* First set the flag in_our_own_code to indicate we are in
		our own interrupt handler. If we use interrupt from
		within our own handler (e.g. by using a the standard C
		library), this interrupt is handled by the original
		handler. */
		in_our_own_code=1;

		/* Save the registers values, which are on the stack,
		into global variables. This makes it possible to access
		them after we have set up our own stack. */
		res=reg_es;
		rds=reg_ds;
		rdi=reg_di;
		rsi=reg_si;
		rbp=reg_bp;
		rsp=reg_sp;
		rbx=reg_bx;
		rdx=reg_dx;
		rcx=reg_cx;
		rax=reg_ax;
		rip=reg_ip;
		rcs=reg_cs;
		rflags=reg_flags;

		/* Save current stack pointer into old_stack_pointer, 
		and load int_handler_stack_pointer into the stack pointer.
		This is for safety since we don't know how much space is
		left on the current stack, but we do know how much space 
		we have on our own stack. Our own stack is the array
		int_handler_stack in main(). Turn off interrupts during the 
		stack switch. */
		_asm
		{
			cli
			mov  WORD PTR old_stack_pointer[0], sp  
			mov  WORD PTR old_stack_pointer[2], ss
			mov  sp, WORD PTR int_handler_stack_pointer[0] 
			mov  ss, WORD PTR int_handler_stack_pointer[2]
			sti
		}

		/* Save value of old stack pointer for logging purposes. */
		rss=old_stack_pointer[2];

		/* Remember the interrupt number. */
		current_interrupt_no=(unsigned int)spy_tab[0].interrupt_no;

		/* Do all loggings. */
		spy(int_tab[0]);

		/* Restore the original stack. Turn off interrupts during 
		the stack switch. */
		_asm
		{
			cli
			mov  sp, WORD PTR old_stack_pointer[0]
			mov  ss, WORD PTR old_stack_pointer[2]
			sti
		}

		/* Copy the register values back from the global
		variables onto the stack. If the interrupt returns,
		these values are popped from the stack into the
		registers. */
		reg_es=res;
		reg_ds=rds;
		reg_di=rdi;
		reg_si=rsi;
		reg_bp=rbp;
		reg_sp=rsp;
		reg_bx=rbx;
		reg_dx=rdx;
		reg_cx=rcx;
		reg_ax=rax;
		reg_ip=rip;
		reg_cs=rcs;
		reg_flags=rflags;

		/* Clear the flag indicating we are in our own interrupt
		handler. */
		in_our_own_code=0;

		/* Jump to the orriginal interrupt handler. */
		_chain_intr(old_int_handler[0]);

	}
}


/* Own interupt handler number 1. */
void _interrupt _far new_int_handler_1(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags)
{
	/* If the flag in_our_own_code is set, interrupt is recursively
	called by our own interrupt handler. In this case we chain to
	the original interrupt handler. */
	if(in_our_own_code)_chain_intr(old_int_handler[1]);

	/* Otherwise we will do our own interrupt processing. */
	else 
	{
		/* First set the flag in_our_own_code to indicate we are in
		our own interrupt handler. If we use interrupt from
		within our own handler (e.g. by using a the standard C
		library), this interrupt is handled by the original
		handler. */
		in_our_own_code=1;

		/* Save the registers values, which are on the stack,
		into global variables. This makes it possible to access
		them after we have set up our own stack. */
		res=reg_es;
		rds=reg_ds;
		rdi=reg_di;
		rsi=reg_si;
		rbp=reg_bp;
		rsp=reg_sp;
		rbx=reg_bx;
		rdx=reg_dx;
		rcx=reg_cx;
		rax=reg_ax;
		rip=reg_ip;
		rcs=reg_cs;
		rflags=reg_flags;

		/* Save current stack pointer into old_stack_pointer, 
		and load int_handler_stack_pointer into the stack pointer.
		This is for safety since we don't know how much space is
		left on the current stack, but we do know how much space 
		we have on our own stack. Our own stack is the array
		int_handler_stack in main(). Turn off interrupts during the 
		stack switch. */
		_asm
		{
			cli
			mov  WORD PTR old_stack_pointer[0], sp  
			mov  WORD PTR old_stack_pointer[2], ss
			mov  sp, WORD PTR int_handler_stack_pointer[0] 
			mov  ss, WORD PTR int_handler_stack_pointer[2]
			sti
		}

		/* Save value of old stack pointer for logging purposes. */
		rss=old_stack_pointer[2];

		/* Remember the interrupt number. */
		current_interrupt_no=(unsigned int)spy_tab[1].interrupt_no;

		/* Do all loggings. */
		spy(int_tab[1]);

		/* Restore the original stack. Turn off interrupts during 
		the stack switch. */
		_asm
		{
			cli
			mov  sp, WORD PTR old_stack_pointer[0]
			mov  ss, WORD PTR old_stack_pointer[2]
			sti
		}

		/* Copy the register values back from the global
		variables onto the stack. If the interrupt returns,
		these values are popped from the stack into the
		registers. */
		reg_es=res;
		reg_ds=rds;
		reg_di=rdi;
		reg_si=rsi;
		reg_bp=rbp;
		reg_sp=rsp;
		reg_bx=rbx;
		reg_dx=rdx;
		reg_cx=rcx;
		reg_ax=rax;
		reg_ip=rip;
		reg_cs=rcs;
		reg_flags=rflags;

		/* Clear the flag indicating we are in our own interrupt
		handler. */
		in_our_own_code=0;

		/* Jump to the orriginal interrupt handler. */
		_chain_intr(old_int_handler[1]);

	}
}




/* Own interupt handler number 2. */
void _interrupt _far new_int_handler_2(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags)
{
	/* If the flag in_our_own_code is set, interrupt is recursively
	called by our own interrupt handler. In this case we chain to
	the original interrupt handler. */
	if(in_our_own_code)_chain_intr(old_int_handler[2]);

	/* Otherwise we will do our own interrupt processing. */
	else 
	{
		/* First set the flag in_our_own_code to indicate we are in
		our own interrupt handler. If we use interrupt from
		within our own handler (e.g. by using a the standard C
		library), this interrupt is handled by the original
		handler. */
		in_our_own_code=1;

		/* Save the registers values, which are on the stack,
		into global variables. This makes it possible to access
		them after we have set up our own stack. */
		res=reg_es;
		rds=reg_ds;
		rdi=reg_di;
		rsi=reg_si;
		rbp=reg_bp;
		rsp=reg_sp;
		rbx=reg_bx;
		rdx=reg_dx;
		rcx=reg_cx;
		rax=reg_ax;
		rip=reg_ip;
		rcs=reg_cs;
		rflags=reg_flags;

		/* Save current stack pointer into old_stack_pointer, 
		and load int_handler_stack_pointer into the stack pointer.
		This is for safety since we don't know how much space is
		left on the current stack, but we do know how much space 
		we have on our own stack. Our own stack is the array
		int_handler_stack in main(). Turn off interrupts during the 
		stack switch. */
		_asm
		{
			cli
			mov  WORD PTR old_stack_pointer[0], sp  
			mov  WORD PTR old_stack_pointer[2], ss
			mov  sp, WORD PTR int_handler_stack_pointer[0] 
			mov  ss, WORD PTR int_handler_stack_pointer[2]
			sti
		}

		/* Save value of old stack pointer for logging purposes. */
		rss=old_stack_pointer[2];

		/* Remember the interrupt number. */
		current_interrupt_no=(unsigned int)spy_tab[2].interrupt_no;

		/* Do all loggings. */
		spy(int_tab[2]);

		/* Restore the original stack. Turn off interrupts during 
		the stack switch. */
		_asm
		{
			cli
			mov  sp, WORD PTR old_stack_pointer[0]
			mov  ss, WORD PTR old_stack_pointer[2]
			sti
		}

		/* Copy the register values back from the global
		variables onto the stack. If the interrupt returns,
		these values are popped from the stack into the
		registers. */
		reg_es=res;
		reg_ds=rds;
		reg_di=rdi;
		reg_si=rsi;
		reg_bp=rbp;
		reg_sp=rsp;
		reg_bx=rbx;
		reg_dx=rdx;
		reg_cx=rcx;
		reg_ax=rax;
		reg_ip=rip;
		reg_cs=rcs;
		reg_flags=rflags;

		/* Clear the flag indicating we are in our own interrupt
		handler. */
		in_our_own_code=0;

		/* Jump to the orriginal interrupt handler. */
		_chain_intr(old_int_handler[2]);

	}
}




/* Own interupt handler number 3. */
void _interrupt _far new_int_handler_3(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags)
{
	/* If the flag in_our_own_code is set, interrupt is recursively
	called by our own interrupt handler. In this case we chain to
	the original interrupt handler. */
	if(in_our_own_code)_chain_intr(old_int_handler[3]);

	/* Otherwise we will do our own interrupt processing. */
	else 
	{
		/* First set the flag in_our_own_code to indicate we are in
		our own interrupt handler. If we use interrupt from
		within our own handler (e.g. by using a the standard C
		library), this interrupt is handled by the original
		handler. */
		in_our_own_code=1;

		/* Save the registers values, which are on the stack,
		into global variables. This makes it possible to access
		them after we have set up our own stack. */
		res=reg_es;
		rds=reg_ds;
		rdi=reg_di;
		rsi=reg_si;
		rbp=reg_bp;
		rsp=reg_sp;
		rbx=reg_bx;
		rdx=reg_dx;
		rcx=reg_cx;
		rax=reg_ax;
		rip=reg_ip;
		rcs=reg_cs;
		rflags=reg_flags;

		/* Save current stack pointer into old_stack_pointer, 
		and load int_handler_stack_pointer into the stack pointer.
		This is for safety since we don't know how much space is
		left on the current stack, but we do know how much space 
		we have on our own stack. Our own stack is the array
		int_handler_stack in main(). Turn off interrupts during the 
		stack switch. */
		_asm
		{
			cli
			mov  WORD PTR old_stack_pointer[0], sp  
			mov  WORD PTR old_stack_pointer[2], ss
			mov  sp, WORD PTR int_handler_stack_pointer[0] 
			mov  ss, WORD PTR int_handler_stack_pointer[2]
			sti
		}

		/* Save value of old stack pointer for logging purposes. */
		rss=old_stack_pointer[2];

		/* Remember the interrupt number. */
		current_interrupt_no=(unsigned int)spy_tab[3].interrupt_no;

		/* Do all loggings. */
		spy(int_tab[3]);

		/* Restore the original stack. Turn off interrupts during 
		the stack switch. */
		_asm
		{
			cli
			mov  sp, WORD PTR old_stack_pointer[0]
			mov  ss, WORD PTR old_stack_pointer[2]
			sti
		}

		/* Copy the register values back from the global
		variables onto the stack. If the interrupt returns,
		these values are popped from the stack into the
		registers. */
		reg_es=res;
		reg_ds=rds;
		reg_di=rdi;
		reg_si=rsi;
		reg_bp=rbp;
		reg_sp=rsp;
		reg_bx=rbx;
		reg_dx=rdx;
		reg_cx=rcx;
		reg_ax=rax;
		reg_ip=rip;
		reg_cs=rcs;
		reg_flags=rflags;

		/* Clear the flag indicating we are in our own interrupt
		handler. */
		in_our_own_code=0;

		/* Jump to the orriginal interrupt handler. */
		_chain_intr(old_int_handler[3]);

	}
}




/* Own interupt handler number 4. */
void _interrupt _far new_int_handler_4(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags)
{
	/* If the flag in_our_own_code is set, interrupt is recursively
	called by our own interrupt handler. In this case we chain to
	the original interrupt handler. */
	if(in_our_own_code)_chain_intr(old_int_handler[4]);

	/* Otherwise we will do our own interrupt processing. */
	else 
	{
		/* First set the flag in_our_own_code to indicate we are in
		our own interrupt handler. If we use interrupt from
		within our own handler (e.g. by using a the standard C
		library), this interrupt is handled by the original
		handler. */
		in_our_own_code=1;

		/* Save the registers values, which are on the stack,
		into global variables. This makes it possible to access
		them after we have set up our own stack. */
		res=reg_es;
		rds=reg_ds;
		rdi=reg_di;
		rsi=reg_si;
		rbp=reg_bp;
		rsp=reg_sp;
		rbx=reg_bx;
		rdx=reg_dx;
		rcx=reg_cx;
		rax=reg_ax;
		rip=reg_ip;
		rcs=reg_cs;
		rflags=reg_flags;

		/* Save current stack pointer into old_stack_pointer, 
		and load int_handler_stack_pointer into the stack pointer.
		This is for safety since we don't know how much space is
		left on the current stack, but we do know how much space 
		we have on our own stack. Our own stack is the array
		int_handler_stack in main(). Turn off interrupts during the 
		stack switch. */
		_asm
		{
			cli
			mov  WORD PTR old_stack_pointer[0], sp  
			mov  WORD PTR old_stack_pointer[2], ss
			mov  sp, WORD PTR int_handler_stack_pointer[0] 
			mov  ss, WORD PTR int_handler_stack_pointer[2]
			sti
		}

		/* Save value of old stack pointer for logging purposes. */
		rss=old_stack_pointer[2];

		/* Remember the interrupt number. */
		current_interrupt_no=(unsigned int)spy_tab[4].interrupt_no;

		/* Do all loggings. */
		spy(int_tab[4]);

		/* Restore the original stack. Turn off interrupts during 
		the stack switch. */
		_asm
		{
			cli
			mov  sp, WORD PTR old_stack_pointer[0]
			mov  ss, WORD PTR old_stack_pointer[2]
			sti
		}

		/* Copy the register values back from the global
		variables onto the stack. If the interrupt returns,
		these values are popped from the stack into the
		registers. */
		reg_es=res;
		reg_ds=rds;
		reg_di=rdi;
		reg_si=rsi;
		reg_bp=rbp;
		reg_sp=rsp;
		reg_bx=rbx;
		reg_dx=rdx;
		reg_cx=rcx;
		reg_ax=rax;
		reg_ip=rip;
		reg_cs=rcs;
		reg_flags=rflags;

		/* Clear the flag indicating we are in our own interrupt
		handler. */
		in_our_own_code=0;

		/* Jump to the orriginal interrupt handler. */
		_chain_intr(old_int_handler[4]);

	}
}




/* Own interupt handler number 5. */
void _interrupt _far new_int_handler_5(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags)
{
	/* If the flag in_our_own_code is set, interrupt is recursively
	called by our own interrupt handler. In this case we chain to
	the original interrupt handler. */
	if(in_our_own_code)_chain_intr(old_int_handler[5]);

	/* Otherwise we will do our own interrupt processing. */
	else 
	{
		/* First set the flag in_our_own_code to indicate we are in
		our own interrupt handler. If we use interrupt from
		within our own handler (e.g. by using a the standard C
		library), this interrupt is handled by the original
		handler. */
		in_our_own_code=1;

		/* Save the registers values, which are on the stack,
		into global variables. This makes it possible to access
		them after we have set up our own stack. */
		res=reg_es;
		rds=reg_ds;
		rdi=reg_di;
		rsi=reg_si;
		rbp=reg_bp;
		rsp=reg_sp;
		rbx=reg_bx;
		rdx=reg_dx;
		rcx=reg_cx;
		rax=reg_ax;
		rip=reg_ip;
		rcs=reg_cs;
		rflags=reg_flags;

		/* Save current stack pointer into old_stack_pointer, 
		and load int_handler_stack_pointer into the stack pointer.
		This is for safety since we don't know how much space is
		left on the current stack, but we do know how much space 
		we have on our own stack. Our own stack is the array
		int_handler_stack in main(). Turn off interrupts during the 
		stack switch. */
		_asm
		{
			cli
			mov  WORD PTR old_stack_pointer[0], sp  
			mov  WORD PTR old_stack_pointer[2], ss
			mov  sp, WORD PTR int_handler_stack_pointer[0] 
			mov  ss, WORD PTR int_handler_stack_pointer[2]
			sti
		}

		/* Save value of old stack pointer for logging purposes. */
		rss=old_stack_pointer[2];

		/* Remember the interrupt number. */
		current_interrupt_no=(unsigned int)spy_tab[5].interrupt_no;

		/* Do all loggings. */
		spy(int_tab[5]);

		/* Restore the original stack. Turn off interrupts during 
		the stack switch. */
		_asm
		{
			cli
			mov  sp, WORD PTR old_stack_pointer[0]
			mov  ss, WORD PTR old_stack_pointer[2]
			sti
		}

		/* Copy the register values back from the global
		variables onto the stack. If the interrupt returns,
		these values are popped from the stack into the
		registers. */
		reg_es=res;
		reg_ds=rds;
		reg_di=rdi;
		reg_si=rsi;
		reg_bp=rbp;
		reg_sp=rsp;
		reg_bx=rbx;
		reg_dx=rdx;
		reg_cx=rcx;
		reg_ax=rax;
		reg_ip=rip;
		reg_cs=rcs;
		reg_flags=rflags;

		/* Clear the flag indicating we are in our own interrupt
		handler. */
		in_our_own_code=0;

		/* Jump to the orriginal interrupt handler. */
		_chain_intr(old_int_handler[5]);

	}
}




/* Own interupt handler number 6. */
void _interrupt _far new_int_handler_6(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags)
{
	/* If the flag in_our_own_code is set, interrupt is recursively
	called by our own interrupt handler. In this case we chain to
	the original interrupt handler. */
	if(in_our_own_code)_chain_intr(old_int_handler[6]);

	/* Otherwise we will do our own interrupt processing. */
	else 
	{
		/* First set the flag in_our_own_code to indicate we are in
		our own interrupt handler. If we use interrupt from
		within our own handler (e.g. by using a the standard C
		library), this interrupt is handled by the original
		handler. */
		in_our_own_code=1;

		/* Save the registers values, which are on the stack,
		into global variables. This makes it possible to access
		them after we have set up our own stack. */
		res=reg_es;
		rds=reg_ds;
		rdi=reg_di;
		rsi=reg_si;
		rbp=reg_bp;
		rsp=reg_sp;
		rbx=reg_bx;
		rdx=reg_dx;
		rcx=reg_cx;
		rax=reg_ax;
		rip=reg_ip;
		rcs=reg_cs;
		rflags=reg_flags;

		/* Save current stack pointer into old_stack_pointer, 
		and load int_handler_stack_pointer into the stack pointer.
		This is for safety since we don't know how much space is
		left on the current stack, but we do know how much space 
		we have on our own stack. Our own stack is the array
		int_handler_stack in main(). Turn off interrupts during the 
		stack switch. */
		_asm
		{
			cli
			mov  WORD PTR old_stack_pointer[0], sp  
			mov  WORD PTR old_stack_pointer[2], ss
			mov  sp, WORD PTR int_handler_stack_pointer[0] 
			mov  ss, WORD PTR int_handler_stack_pointer[2]
			sti
		}

		/* Save value of old stack pointer for logging purposes. */
		rss=old_stack_pointer[2];

		/* Remember the interrupt number. */
		current_interrupt_no=(unsigned int)spy_tab[6].interrupt_no;

		/* Do all loggings. */
		spy(int_tab[6]);

		/* Restore the original stack. Turn off interrupts during 
		the stack switch. */
		_asm
		{
			cli
			mov  sp, WORD PTR old_stack_pointer[0]
			mov  ss, WORD PTR old_stack_pointer[2]
			sti
		}

		/* Copy the register values back from the global
		variables onto the stack. If the interrupt returns,
		these values are popped from the stack into the
		registers. */
		reg_es=res;
		reg_ds=rds;
		reg_di=rdi;
		reg_si=rsi;
		reg_bp=rbp;
		reg_sp=rsp;
		reg_bx=rbx;
		reg_dx=rdx;
		reg_cx=rcx;
		reg_ax=rax;
		reg_ip=rip;
		reg_cs=rcs;
		reg_flags=rflags;

		/* Clear the flag indicating we are in our own interrupt
		handler. */
		in_our_own_code=0;

		/* Jump to the orriginal interrupt handler. */
		_chain_intr(old_int_handler[6]);

	}
}




/* Own interupt handler number 7. */
void _interrupt _far new_int_handler_7(unsigned int reg_es,
	unsigned int reg_ds,unsigned int reg_di,unsigned int reg_si,
	unsigned int reg_bp,unsigned int reg_sp,unsigned int reg_bx,
	unsigned int reg_dx,unsigned int reg_cx,unsigned int reg_ax,
	unsigned int reg_ip,unsigned int reg_cs,unsigned int reg_flags)
{
	/* If the flag in_our_own_code is set, interrupt is recursively
	called by our own interrupt handler. In this case we chain to
	the original interrupt handler. */
	if(in_our_own_code)_chain_intr(old_int_handler[7]);

	/* Otherwise we will do our own interrupt processing. */
	else 
	{
		/* First set the flag in_our_own_code to indicate we are in
		our own interrupt handler. If we use interrupt from
		within our own handler (e.g. by using a the standard C
		library), this interrupt is handled by the original
		handler. */
		in_our_own_code=1;

		/* Save the registers values, which are on the stack,
		into global variables. This makes it possible to access
		them after we have set up our own stack. */
		res=reg_es;
		rds=reg_ds;
		rdi=reg_di;
		rsi=reg_si;
		rbp=reg_bp;
		rsp=reg_sp;
		rbx=reg_bx;
		rdx=reg_dx;
		rcx=reg_cx;
		rax=reg_ax;
		rip=reg_ip;
		rcs=reg_cs;
		rflags=reg_flags;

		/* Save current stack pointer into old_stack_pointer, 
		and load int_handler_stack_pointer into the stack pointer.
		This is for safety since we don't know how much space is
		left on the current stack, but we do know how much space 
		we have on our own stack. Our own stack is the array
		int_handler_stack in main(). Turn off interrupts during the 
		stack switch. */
		_asm
		{
			cli
			mov  WORD PTR old_stack_pointer[0], sp  
			mov  WORD PTR old_stack_pointer[2], ss
			mov  sp, WORD PTR int_handler_stack_pointer[0] 
			mov  ss, WORD PTR int_handler_stack_pointer[2]
			sti
		}

		/* Save value of old stack pointer for logging purposes. */
		rss=old_stack_pointer[2];

		/* Remember the interrupt number. */
		current_interrupt_no=(unsigned int)spy_tab[7].interrupt_no;

		/* Do all loggings. */
		spy(int_tab[7]);

		/* Restore the original stack. Turn off interrupts during 
		the stack switch. */
		_asm
		{
			cli
			mov  sp, WORD PTR old_stack_pointer[0]
			mov  ss, WORD PTR old_stack_pointer[2]
			sti
		}

		/* Copy the register values back from the global
		variables onto the stack. If the interrupt returns,
		these values are popped from the stack into the
		registers. */
		reg_es=res;
		reg_ds=rds;
		reg_di=rdi;
		reg_si=rsi;
		reg_bp=rbp;
		reg_sp=rsp;
		reg_bx=rbx;
		reg_dx=rdx;
		reg_cx=rcx;
		reg_ax=rax;
		reg_ip=rip;
		reg_cs=rcs;
		reg_flags=rflags;

		/* Clear the flag indicating we are in our own interrupt
		handler. */
		in_our_own_code=0;

		/* Jump to the orriginal interrupt handler. */
		_chain_intr(old_int_handler[7]);

	}
}



